library wkRandomMap;

// wkRandomMap source
// All this code is published over GNU General Public License
// http://www.gnu.org/licenses/gpl.html
// You may choose of using either GNU GPL v2 or later (v3, etc)
// No commentaries, sorry
// Before compiling you should download corresponding modules (see "Uses" section)
// Compiled on Delphi 7

uses
  SysUtils,
  Windows,
  Messages,
  WinInet,
  StrUtils,
  madCHook in 'D:\Develop\madCollection\madCodeHook\Dll\madCHook.pas',          // Find those modules in the internet
  madTools in 'D:\Develop\madCollection\madBasic\Sources\madTools.pas',         // Google for "MadCollection_old.rar"
  madTypes in 'D:\Develop\madCollection\madBasic\Sources\madTypes.pas',
  madStrings in 'D:\Develop\madCollection\madBasic\Sources\madStrings.pas',
  DirectDraw in 'D:\Develop\JEDI\DirectDraw.pas';                               // Clootie DirectX headers http://www.clootie.ru/

var
  IDDRAW: IDirectDraw=nil;
  Surf:IDirectDrawSurface=nil;
  Hooking:boolean=true;
  //LastMap:String='';
  DDrawReady:boolean=false;
  SurfaceReady:boolean=false;
  SurfRef:integer;
  DoExit:Boolean = false;

type
  TMapData=record
    Name:String;
    Author:String;
    genre:String;
    ViewsDownloads:String;
    Features:String;
    IsEmpty:boolean;
  end;

const
  ConError:String='graphics\ConnectionError.png';
  HistoryDir:String='User\SavedLevels\Random maps history\';

{procedure signal;
begin
  beep(1000,400);
  sleep(200);
end;}

function MustExit:boolean;
begin
  result:=DoExit or (GetAsyncKeyState(VK_ESCAPE)<>0);
end;

function GetDC:hdc;
begin
  Surf.GetDC(result);
  SetBkColor(result,$000000);
  SetTextColor(result,$FFFFFF);
end;

function GetPageCount(const s:string):integer;
var
  p,p2:integer;
  s2:string;
  code:integer;
begin
  p:=pos('style="width:25px" class="text" />',s);
  if p=0 then result:=1 else begin
    p:=p+39;
    p2:=posex(' ',s,p)-p;
    s2:=copy(s,p,p2);
    val(s2,result,code);
    if code<>0 then result:=0;
  end;
end;

function GetMapsCount(const s:string):integer;
var
  p,p2:integer;
begin
  p2:=1;
  result:=0;
  while true do begin
    p:=PosEx('/images/maps/small/',s,p2);
    if p=0 then exit else begin
      inc(result);
      p2:=p+13;
    end;
  end;
end;

function GetMidStr(const S:string; var p:Integer; const s1,s2:string; out OutStr:String):boolean;
var
  p1,p2:integer;
begin
  result:=false;
  OutStr:='';
  p1:=PosEx(s1,S,p);
  if p1=0 then exit;
  p1:=p1+length(s1);
  p2:=PosEx(s2,S,p1);
  if p2=0 then exit;
  p:=p2+length(s2);
  p2:=p2-p1;
  OutStr:=copy(s,p1,p2);
  result:=true;
end;

function GetMapID(const S:string; MapNum:Integer;out MapData:TMapData):integer;
var
  p,p2:integer;
  i:integer;
  s2:string;
  code:integer;
begin
  p2:=1;
  result:=0;
  MapData.IsEmpty:=true;
  for i:=0 to mapNum do begin
    p:=PosEx('/images/maps/small/',s,p2);
    if p=0 then exit;
    p2:=p+19;
  end;
  p:=PosEx('.',s,p2)-p2;
  if p<=0 then exit;
  s2:=copy(s,p2,p);
  val(s2,result,code);
  if code<>0 then result:=0 else begin
    p:=PosEx('<div class="title">',S,p2);
    if GetMidStr(S,p,'<a href="/'+s2+'">','</a>',MapData.Name) and
       GetMidStr(S,p,'<a href="/users/','">',MapData.Author) and
       GetMidStr(S,p,'<a href="/maps/','">',MapData.Genre) and
       GetMidStr(S,p,'<b>Views/Downloads:</b> ','<br />',MapData.ViewsDownloads) and
       GetMidStr(S,p,'<b>Features:</b> ','<br />',MapData.Features) then begin
         MapData.IsEmpty:=false;
       end;
  end;
end;

function DataToString(Data:Pointer; Size:Cardinal):string;
begin
  setlength(result,Size);
  MoveMemory(@result[1],Data,Size);
end;

procedure DrawStatusText(DC:HDC;Font:HFont;const Text:String);
var
  br,obr:HBRUSH;
  ofont:HFont;
begin
  br:=CreateSolidBrush($000000);
  obr:=SelectObject(DC,br);
  ofont:=SelectObject(DC,font);
  rectangle(DC,150,160,600,180);
  TextOut(DC,150,160,@text[1],length(text));
  selectobject(dc,ofont);
  SelectObject(DC,obr);
  deleteobject(br);
end;

procedure DrawMapData(DC:HDC; Font:HFont; MapData:TMapData);
  procedure Text(DC:HDC;Y:Integer;const Text:String);
  begin
    TextOut(DC,150,Y,@Text[1],Length(Text));
  end;
var
  ofont:HFont;
begin
  if MapData.IsEmpty then exit;
  ofont:=SelectObject(DC,Font);
  text(DC,180,'Map: '+MapData.Name+' ['+MapData.genre+']');
  text(DC,193,'by '+MapData.Author);
  text(DC,206,'Views/Downloads: '+MapData.ViewsDownloads);
  text(DC,219,'Features: '+MapData.Features);
  SelectObject(DC,ofont);
end;

procedure DrawStstusBar(DC:HDC; max,current:integer);
var
  br,obr:HBRUSH;
  X:integer;
begin
  if max=0 then exit;
  X:=round(450*current/max)+154;
  br:=CreateSolidBrush($FFFFFF);
  obr:=SelectObject(DC,br);
  Rectangle(DC,152,242,X,257);
  SelectObject(DC,obr);
  deleteobject(br);
end;

procedure GetData(URL:String; Inet:HINTERNET; var P:Pointer; var Size:Cardinal; NeedDraw:boolean; Font:HFont; SizeRequest:boolean; DisplayString:String);
var
  Connection:HINTERNET;
  Request:HINTERNET;
  RSize,reserved:Cardinal;
  Cur:Cardinal;
  BufNew,ReadedSize:Cardinal;
  DC:HDC;
  NewPtr:Pointer;
begin
  //IDDRAW.FlipToGDISurface;
  p:=nil;
  request:=nil;
  reserved:=0;
  RSize:=4;
  size:=0;
  Connection:=InternetConnectA(Inet,'wmdb.org',INTERNET_DEFAULT_HTTP_PORT,'anonymous',nil,INTERNET_SERVICE_HTTP,0,0);
  if MustExit then exit;
  if connection<>nil then Request:=HttpOpenRequestA(Connection,nil,@url[1],nil,nil,nil,INTERNET_FLAG_PRAGMA_NOCACHE or INTERNET_FLAG_RELOAD,0);
  if MustExit then exit;
  if (request<>nil) and HttpSendRequestA(Request,nil,0,nil,0) and ((not SizeRequest) or HttpQueryInfoA(Request,HTTP_QUERY_CONTENT_LENGTH or HTTP_QUERY_FLAG_NUMBER,@size,RSize,reserved)) then begin
    if MustExit then exit;
    getmem(P,size);
    Cur:=0;
    while (Cur<Size) or (not SizeRequest) do begin
      if (not InternetQueryDataAvailable(request,BufNew,0,0)) or (MustExit) then begin
        FreeMem(p,size);
        exit;
      end;
      if BufNew=0 then break;
      if (BufNew>(Size-Cur)) and SizeRequest then BufNew:=size-cur;
      if not SizeRequest then begin
        getmem(NewPtr,cur+BufNew);
        MoveMemory(NewPtr,P,Cur);
        FreeMem(P,Cur);
        P:=NewPtr;
        Size:=cur+BufNew;
      end;
      if not InternetReadFile(Request,pointer(Cardinal(p)+cur),BufNew,ReadedSize) then break;
      Cur:=Cur+ReadedSize;
      if NeedDraw then begin
        DC:=GetDC;
        if SizeRequest then begin
          DrawStatusText(DC,Font,DisplayString+inttostr(Cur shr 10)+' of '+inttostr(size shr 10)+' KBytes done...');
          DrawStstusBar(DC,Size,Cur);
        end else DrawStatusText(DC,Font,DisplayString+inttostr(Cur shr 10)+' KBytes done...');
        Surf.ReleaseDC(DC);
      end;
    end;
  end;
end;

procedure LoadFromFile(fname:String; var P:Pointer; var Size:Cardinal);
var
  F:File of byte;
begin
  Assignfile(F,fname);
  reset(F);
  size:=FileSize(f);
  GetMem(P,size);
  BlockRead(f,P^,Size);
  Closefile(F);
end;

procedure GetMap(out FName:String; URL:String; Font:HFont);
var
  Inet:HINTERNET;
  F:file of byte;
  P:Pointer;
  Size:Cardinal;
  DC:HDC;
  Page1,PageLast,NeedPage:string;
  PageCount:integer;
  error:boolean;
  symbol:char;
  MapCount:integer;
  MapID:integer;
  MapPage:integer;
  MapData:TMapData;
  FMapCount:integer;
  ForceDownload:boolean;
begin
  error:=true;
  PageLast:='';
  NeedPage:='';
  DC:=GetDC;
  DrawStatusText(DC,Font,'Connecting...');
  Surf.ReleaseDC(DC);
  Inet:=InternetOpenA('WMDB Agent',INTERNET_OPEN_TYPE_PRECONFIG,nil,nil,0);
  FName:='graphics\CancelLoad.png';
  if Inet<>nil then begin
    GetData(URL,Inet,P,Size,true,Font,false,'Loading first page: ');
    if p<>nil then begin
      Page1:=DataToString(P,Size);
      FreeMem(P,Size);
      if MustExit then exit;
      PageCount:=GetPageCount(Page1);
      FMapCount:=GetMapsCount(Page1);
      if pagecount>0 then begin
        if pos('?',URL)=0 then symbol:='?' else symbol:='&';
        if pagecount=1 then PageLast:=Page1 else begin
          DC:=GetDC;
          DrawStatusText(DC,Font,'Retrieving pages list...');
          Surf.ReleaseDC(DC);
          GetData(URL+symbol+'page='+inttostr(pagecount),Inet,P,Size,true,Font,false,'Loading last page: ');
          if p<>nil then begin
            PageLast:=DataToString(P,Size);
            FreeMem(P,Size);
            if MustExit then exit;
          end;
        end;
        if PageLast<>'' then begin
          MapCount:=GetMapsCount(PageLast);
          if MapCount<>0 then begin
            if PageCount=1 then MapID:=MapCount else MapID:=28*(pagecount-2)+MapCount+FMapCount;
            MapId:=random(MapID);
            if MapId<=FMapCount then begin
              MapPage:=0;
            end else begin
              MapId:=MapId-FMapCount+28;
              MapPage:=MapId div 28;
              MapId:=MapId mod 28;
            end;
            if MapPage=0 then NeedPage:=Page1 else begin
              if MapPage=PageCount-1 then NeedPage:=PageLast else begin
                DC:=GetDC;
                DrawStatusText(DC,Font,'Selecting random map...');
                Surf.ReleaseDC(DC);
                GetData(URL+symbol+'page='+inttostr(MapPage+1),Inet,P,Size,true,Font,false,'Loading page #'+inttostr(mappage+1)+': ');
                if p<>nil then begin
                  NeedPage:=DataToString(P,Size);
                  FreeMem(P,Size);
                  if MustExit then exit;
                end;
              end;
            end;
            if NeedPage<>'' then begin
              MapID:=GetMapID(NeedPage,MapID,MapData);
              if MapID<>0 then begin
                DC:=GetDC;
                DrawMapData(DC,Font,MapData);
                DrawStatusText(DC,Font,'Downloading map...');
                Surf.ReleaseDC(DC);
                if not DirectoryExists(HistoryDir) then begin
                  fname:='temp.png';
                  ForceDownload:=true;
                end else begin
                  if MapData.IsEmpty then begin
                    MapData.Name:='Map'+inttostr(MapID)+'.png';
                    fname:=HistoryDir+MapData.Name;
                  end else begin
                    if not DirectoryExists(MapData.genre) then CreateDirectory(PAnsiChar(HistoryDir+MapData.Genre),nil);
                    fname:=HistoryDir+MapData.genre+'\'+MapData.Name+'.png';
                  end;
                  ForceDownload:=false;
                end;
                if ForceDownload or (not FileExists(fname)) then begin
                  GetData('/maps/'+inttostr(MapID)+'-download',Inet,P,Size,true,Font,true,'Downloading map: ');
                  if p<>nil then error:=false;
                end else exit;
              end;
            end;
          end;
        end;
      end;
    end;
    InternetCloseHandle(Inet);
  end;
  if error then begin
    fname:=ConError;
    exit;
  end;
  Assignfile(F,fname);
  rewrite(F);
  BlockWrite(f,P^,Size);
  Closefile(F);
  FreeMem(P,Size);
end;

function GetInterfaceMethod(const intf; methodIndex: dword) : pointer;
begin
  result := pointer(pointer(dword(pointer(intf)^) + methodIndex * 4)^);
end;

var

  CreateFileANext: function (
    lpFileName: PAnsiChar;
    dwDesiredAccess, dwShareMode: DWORD;
    lpSecurityAttributes: PSecurityAttributes;
    dwCreationDisposition, dwFlagsAndAttributes: DWORD;
    hTemplateFile: THandle
  ): THandle; stdcall;

function CreateFileAHook (
  FileName: PAnsiChar;
  dwDesiredAccess, dwShareMode: DWORD;
  lpSecurityAttributes: PSecurityAttributes;
  dwCreationDisposition, dwFlagsAndAttributes: DWORD;
  hTemplateFile: THandle
): THandle; stdcall;
var
  brush, OldBrush:HBrush;
  font, OldFont:HFONT;
  DC:HDC;
  URL:String;
  pen,open:HPEN;
  lpFileName: String;
  H:HFile;
  Size:Cardinal;
  RB:Cardinal;
begin
  DoExit:=false;
  lpFileName:=FileName;
  if hooking and fileexists(FileName) and (Copy(FileName, Length(lpFileName)-3, 4)='.PnG') and ((dwDesiredAccess and GENERIC_READ)<>0) then begin
    hooking:=false;
    H:=CreateFileANext(FileName,dwDesiredAccess,dwShareMode,lpSecurityAttributes,dwCreationDisposition,dwFlagsAndAttributes,hTemplateFile);
    Size:=GetFileSize(H,nil);
    SetLength(url,size);
    ReadFile(H,Url[1],Size,RB,nil);
    if Copy(URL,1,5) = 'LOAD ' then begin
        FileClose(H);
        lpFileName:='Temp.png';
        Delete(URL,1,5);
        DC:=GetDC;
        begin
          brush:=CreateSolidBrush($000000);
          font:=CreateFontA(40,0,0,0,FW_BOLD,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,'Tahoma');
          OldBrush:=SelectObject(DC,brush);
          OldFont:=SelectObject(DC,font);
          Rectangle(DC,135,104,615,278);
          SetTextColor(DC,$80FFFF);
          TextOut(DC,280,110,'Please wait',11);
          DeleteObject(font);
          SetTextColor(DC,$FFFFFF);
          font:=CreateFontA(10,0,0,0,FW_LIGHT,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,'Small fonts');
          SelectObject(DC,font);
          TextOut(DC,285,268,'Made by ShadowTheAge. Maps from http://WMDB.org. Mailto: Safronov.ag@gmail.com',78);
          DeleteObject(font);
          font:=CreateFontA(12,0,0,0,FW_BOLD,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,'Tahoma');
          SelectObject(DC,font);
          //TextOut(DC,150,160,'Your map is loading...',22);
          pen:=CreatePen(PS_SOLID,2,$FFFFFF);
          OPen:=SelectObject(DC,pen);
          rectangle(DC,150,240,607,260);
          SelectObject(DC,open);
          SelectObject(DC,OldBrush);
          SelectObject(DC,OldFont);
          Surf.ReleaseDC(DC);
          DeleteObject(brush);
          DeleteObject(pen);
          GetMap(lpFileName,URL,Font);
          DeleteObject(font);
        end;
      hooking:=true;  
      Result := CreateFileA(PAnsiChar(lpFileName),dwDesiredAccess,dwShareMode,lpSecurityAttributes,dwCreationDisposition,dwFlagsAndAttributes,hTemplateFile);
      exit;
    end;
    hooking:=true;
    FileSeek(H,0,0);
    result:=h;
    exit;
  end;
  Result:=CreateFileANext(FileName,dwDesiredAccess,dwShareMode,lpSecurityAttributes,dwCreationDisposition,dwFlagsAndAttributes,hTemplateFile);
end;



var
  AddRefNext: function(self:pointer): Integer; stdcall;
function AddRefHook(self:pointer): Integer; stdcall;
begin
  result:=AddRefNext(self);
  if self=pointer(Surf) then inc(SurfRef);
end;

var
  ReleaseNext: function(self:pointer): Integer; stdcall;
function ReleaseHook(self:pointer): Integer; stdcall;
begin
  result:=ReleaseNext(self);
  if self=pointer(Surf) then dec(SurfRef);
  if SurfRef=0 then begin
    SurfaceReady:=false;
    integer(surf):=0;
  end;
end;



var
  CreateSurfaceNext: function (self: pointer; var lpDDSurfaceDesc: TDDSurfaceDesc;
        out lplpDDSurface: IDirectDrawSurface;
        pUnkOuter: IUnknown): HResult; stdcall;

function CreateSurfaceHook (self: pointer; var lpDDSurfaceDesc: TDDSurfaceDesc;
        out lplpDDSurface: IDirectDrawSurface;
        pUnkOuter: IUnknown): HResult; stdcall;
begin
  result:=CreateSurfaceNext(self,lpDDSurfaceDesc,lplpDDSurface,pUnkOuter);
  if not SurfaceReady then begin
    SurfaceReady:=true;
    integer(Surf):=integer(lplpDDSurface);
    SurfRef:=1;
    HookCode(GetInterfaceMethod(lplpDDSurface,1),@AddRefHook,@AddRefNext);
    HookCode(GetInterfaceMethod(lplpDDSurface,2),@ReleaseHook,@ReleaseNext);
    HookAPI('kernel32.dll','CreateFileA',@CreateFileAHook,@CreateFileANext);
  end;
end;



var
  DDrawCreateNext: function(lpGUID: PGUID; out lplpDD: IDirectDraw;
    pUnkOuter: IUnknown): HResult; stdcall;

function DDrawCreateHook(lpGUID: PGUID; out lplpDD: IDirectDraw;
    pUnkOuter: IUnknown): HResult; stdcall;
begin
  result:=DDrawCreateNext(lpGUID,lplpDD,pUnkOuter);
  if not DDrawReady then begin
    IDDRAW:=lplpDD;
    DDrawReady:=true;
    HookCode(GetInterfaceMethod(IDDraw,6),@CreateSurfaceHook,@CreateSurfaceNext);
  end;
end;

begin
  randomize;
  HookAPI('ddraw.dll','DirectDrawCreate',@DDrawCreateHook,@DDrawCreateNext);
end.
